# Table of Contents

 - [Overview](#overview)
- [Dumb](#dumb)
- [Average](#average)
- [Smart](#smart)

# Overview

Artificial Intelligence is how we select actions for characters controlled by
the computer. It's essentially just an `automatics` function on combat state: A
function that takes the current state of combat and returns a combat page to
execute.

Due to the nature of the game, and its emphasis on very different powers with
flexible rules and strategies, it is generally recommended that each major
enemy (i.e. boss) has their own custom AI. The engine comes with two very
simple AIs:

1. Dumb
2. Average


# Dumb

The dumb AI selects a random enemy and attacks them. If they are not in range
of any enemies, it selects the closest enemy and tries to get within range,
attacking them if they come within range.

# Average

The average AI assigns each target a weight: whether they are the highest or
lowest energy target, whether or they can come in range this turn, and the stat
gap. The average AI then selects the target with the highest weight and tries
to get within range to attack.


These AI's are intended to be used for minions and trash mobs: characters who
don't have any interesting powers and are there solely to whittle down the
heroes. More sophisticated enemies with their own powers will need their own
AI's.
